package net.minecraftforge.items;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.InventoryBasic;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;

public class SlotItemHandler extends Slot
{
    private static IInventory emptyInventory = new InventoryBasic("[Null]", true, 0);
    private final IItemHandler itemHandler;
    private final int index;

    public SlotItemHandler(IItemHandler itemHandler, int index, int xPosition, int yPosition)
    {
        super(emptyInventory, index, xPosition, yPosition);
        this.itemHandler = itemHandler;
        this.index = index;
    }

    @Override
    public boolean func_75214_a(ItemStack stack)
    {
        if (stack == null)
            return false;
        ItemStack remainder = this.getItemHandler().insertItem(index, stack, true);
        return remainder == null || remainder.field_77994_a < stack.field_77994_a;
    }

    @Override
    public ItemStack func_75211_c()
    {
        return this.getItemHandler().getStackInSlot(index);
    }

    // Override if your IItemHandler does not implement IItemHandlerModifiable
    @Override
    public void func_75215_d(ItemStack stack)
    {
        ((IItemHandlerModifiable) this.getItemHandler()).setStackInSlot(index, stack);
        this.func_75218_e();
    }

    @Override
    public void func_75220_a(ItemStack p_75220_1_, ItemStack p_75220_2_)
    {

    }

    @Override
    public int func_178170_b(ItemStack stack)
    {
        ItemStack maxAdd = stack.func_77946_l();
        maxAdd.field_77994_a = maxAdd.func_77976_d();
        ItemStack currentStack = this.getItemHandler().getStackInSlot(index);
        ItemStack remainder = this.getItemHandler().insertItem(index, maxAdd, true);

        int current = currentStack == null ? 0 : currentStack.field_77994_a;
        int added = maxAdd.field_77994_a - (remainder != null ? remainder.field_77994_a : 0);
        return current + added;
    }

    @Override
    public boolean func_82869_a(EntityPlayer playerIn)
    {
        return this.getItemHandler().extractItem(index, 1, true) != null;
    }

    @Override
    public ItemStack func_75209_a(int amount)
    {
        return this.getItemHandler().extractItem(index, amount, false);
    }

    public IItemHandler getItemHandler()
    {
        return itemHandler;
    }

    @Override
    public boolean isSameInventory(Slot other)
    {
        return other instanceof SlotItemHandler && ((SlotItemHandler) other).getItemHandler() == this.itemHandler;
    }
}
